def SetupROOT():
    gStyle.SetOptFit(1)
    gStyle.SetOptStat(0)

class FitFunctionGauss:

    def __init__(self):
        self.func=TF1('myfunc', MyGauss(),-20.0, 20.0, 7)
        self.func.SetParameters(10.0,   0.001, 0.0,  500.0,     2.0,  100.0,     10.0)
        self.func.SetParNames(  "p0","p1", "Mean","Area1","Sigma1","Area2","Sigma2")
        self.func.SetLineColor(kMagenta)
        self.func.SetParLimits(3,0.0,1.0e12)
        self.func.SetParLimits(5,0.0,1.0e12)
        self.func.SetParLimits(1,-5.0,5.0)

class MyGauss:

    def __call__(self, x, par):
        g1 = (par[3]/(2.*pi*par[4]))*exp(-0.5*((x[0]-par[2])/par[4])**2)
        g2 = (par[5]/(2.*pi*par[6]))*exp(-0.5*((x[0]-par[2])/par[6])**2)
        return par[0]+par[1]*x[0]+g1+g2


    def __init__(self):
        print "I am here"



def fitit(hist,fitFunc):

    print '-------------------------------------------------'
    print '       Fitting Histogram                         '
    
    # Update estimated mean with maximum bin position and areas using #entries
    ib = hist.GetMaximumBin()
    m = hist.GetBinCenter(ib)
    hist.InputFitPars = [0., 0., 0., 0., 0., 0., 0.]
    hist.InputFitPars[2] = m
    a1 = 0.4*hist.GetEntries()
    a2 = 0.2*hist.GetEntries()
    hist.InputFitPars[3] = a1
    hist.InputFitPars[5] = a2
    
    fitFunc.SetRange(hist.FitRange[0],hist.FitRange[1])
    for ip in range(7):
        #print "Par Input/Limits ",hist.InputFitPars[ip]," ",hist.LowerParLimit[ip]," ",hist.UpperParLimit[ip]
        fitFunc.SetParameter(ip,hist.InputFitPars[ip])
        fitFunc.SetParLimits(ip,hist.LowerParLimit[ip],hist.UpperParLimit[ip])
        
    hist.Fit(fitFunc,FitOpt)
    parFit = fitFunc.GetParameters()
    eparFit = fitFunc.GetParErrors()
    
    theFitPar = {}
    theFitPar['value']=std.vector('double')()
    theFitPar['error']=std.vector('double')()
    value = theFitPar['value']
    error = theFitPar['error']
    
    
    print "      Mean = %f"%parFit[2],"+- %f"%eparFit[2]
    print '-------------------------------------------------'
    hist.Draw('e1')
    return 

def InitFunc(func):
    
    func.SetParameters(10.0,   0.001, 0.0,  500.0,     2.0,  100.0,     10.0)
    func.SetParNames(  "p0","p1", "Mean","Area1","Sigma1","Area2","Sigma2")
    func.SetLineColor(kMagenta)
    func.SetParLimits(3,0.0,1.0e12)
    func.SetParLimits(5,0.0,1.0e12)
    func.SetParLimits(1,-5.0,5.0)

class myFitHistos:

    def __init__(self):

        opt = 'REBQ0'

        parm = [10.0,   0.001, 0.0,  500.0,     3.0,  100.0,     8.0]
        range = [-50, 50]
        llim = [0.0,     -5.0, -10000.0, 0.0,  0.5,  0.0, 0.5]
        ulim = [10000.0,  5.0,  10000.0, 0.0, 20.0,  0.0, 20.0]
        self.dxh = DeltaX
        self.dxh.InputFitPars = parm
        self.dxh.FitRange = range
        self.dxh.LowerParLimit = llim
        self.dxh.UpperParLimit = ulim
        self.dxh.FitOpt = opt
        self.dxh.name = 'Delta X'

        parm = [10.0,   0.001, 0.0,  500.0,     2.0,  100.0,     10.0]
        range = [-50, 50]
        llim = [0.0,     -5.0, -10000.0, 0.0,    0.5,  0.0,  0.5]
        ulim = [10000.0,  5.0,  10000.0, 0.0, 20.0,    0.0, 20.0]
        self.dyh = DeltaY
        self.dyh.InputFitPars = parm
        self.dyh.FitRange = range
        self.dyh.LowerParLimit = llim
        self.dyh.UpperParLimit = ulim
        self.dyh.FitOpt = opt
        self.dyh.name = 'Delta Y'

        parm = [10.0,   0.001, 0.0,  500.0,     0.8,  100.0,     3.0]
        range = [-20, 20]
        llim = [0.0,     -5.0, -10.0, 0.0,  0.3, 0.0,    0.3]
        ulim = [10000.0,  5.0,  10.0, 0.0, 10.0, 0.0,   10.0]
        self.dxsh = DeltaXSlope
        self.dxsh.InputFitPars = parm
        self.dxsh.FitRange = range
        self.dxsh.LowerParLimit = llim
        self.dxsh.UpperParLimit = ulim
        self.dxsh.FitOpt = opt
        self.dxsh.name = 'Delta X Slope'
        
        parm = [10.0,   0.001, 0.0,  100.0,     0.8,  100.0,     3.0]
        range = [-20, 20]
        llim = [0.0,     -5.0, -10.0, 0.0,  0.5, 0.0, 0.5]
        ulim = [10000.0,  5.0,  10.0, 0.0, 10.0, 0.0, 10.]
        self.dysh = DeltaYSlope
        self.dysh.InputFitPars = parm
        self.dysh.FitRange = range
        self.dysh.LowerParLimit = llim
        self.dysh.UpperParLimit = ulim
        self.dysh.FitOpt = opt
        self.dysh.name = 'Delta Y Slope'

        
        parm = [10.0,   0.001, 5300,  100.0,     30,  50.0,     60]
        range = [5000, 5600]
        llim = [0.0,     -5.0, -10000.0, 0.0,    1.0, 0.0,   1.0]
        ulim = [10000.0,  5.0,  10000.0, 0.0, 2000.0, 0.0, 2000.0]
        self.zinth = Zint
        self.zinth.InputFitPars = parm
        self.zinth.FitRange = range
        self.zinth.LowerParLimit = llim
        self.zinth.UpperParLimit = ulim
        self.zinth.FitOpt = opt
        self.zinth.name = 'Z of Magnet Center'


        
        parm = [10.0, 0.001,  0.0,  5000.0,  20,  1000.0,  50]
        range = [-150, 150]
        llim = [0.0,     -5.0, -10000.0, 0.0,   2.0,  0.0, 2.0]
        ulim = [10000.0,  5.0,  10000.0, 0.0, 500.0,  0.0, 500.]
        self.dphih = DeltaPhi
        self.dphih.InputFitPars = parm
        self.dphih.FitRange = range
        self.dphih.LowerParLimit = llim
        self.dphih.UpperParLimit = ulim
        self.dphih.FitOpt = opt
        self.dphih.name = 'Delta Phi'
        
        parm = [10.0, 0.001,  0.0001,  100.0,  150.,  100.0,     400.]
        range = [-700, 700]
        llim = [0.0,     -5.0, -10000.0, 0.0,  20.0, 0.0,  20.0]
        ulim = [10000.0,  5.0,  10000.0, 0.0, 500.0, 0.0, 500.0]
        self.dzxh = DeltaZX
        self.dzxh.InputFitPars = parm
        self.dzxh.FitRange = range
        self.dzxh.LowerParLimit = llim
        self.dzxh.UpperParLimit = ulim
        self.dzxh.FitOpt = opt
        self.dzxh.name = 'Delta Z (X view)'


        parm = [10.0, 0.001,  0.0001,  100.0,  150.,  100.0,     400.]
        range = [-700, 700]
        llim = [0.0,     -5.0, -10000.0, 0.0,   20.0, 0.0,   20.0]
        ulim = [10000.0,  5.0,  10000.0, 0.0, 5000.0, 0.0, 5000.0]
        self.dzyh = DeltaZY
        self.dzyh.InputFitPars = parm
        self.dzyh.FitRange = range
        self.dzyh.LowerParLimit = llim
        self.dzyh.UpperParLimit = ulim
        self.dzyh.FitOpt = opt
        self.dzyh.name = 'Delta Z (Y view)'

        
        parm = [10.0, 0.001,  0.0001,  100.0,  150.,  100.0,     400.]
        range = [-700, 700]
        llim = [0.0,     -5.0, -10000.0, 0.0,   20.0, 0.0,   20.0]
        ulim = [10000.0,  5.0,  10000.0, 0.0, 5000.0, 0.0, 5000.0]
        self.dzh = DeltaZ
        self.dzh.InputFitPars = parm
        self.dzh.FitRange = range
        self.dzh.LowerParLimit = llim
        self.dzh.UpperParLimit = ulim
        self.dzh.FitOpt = opt
        self.dzh.name = 'Delta Z'

def Plot():
    tks = TCanvas('tks','Plots',800,800)
    tks.Divide(2,3)
    tks.cd(1)
    job.dxh.Draw('e1')
    tks.cd(2)
    job.dxsh.Draw('e1')
    tks.cd(3)
    job.dyh.Draw('e1')
    tks.cd(4)
    job.dysh.Draw('e1')
    tks.cd(5)
    job.dzxh.Draw('e1')
    tks.cd(6)
    job.dphih.Draw('e1')

    

from ROOT import *
import math
pi = math.pi
SetupROOT()

FitOpt = 'REBQ'
file = "VeloTAlign_Iter_0_0.root"
f=TFile(file)

job=myFitHistos()

fitFunc = TF1('myfunc', MyGauss(),-20.0, 20.0, 7)
print "I have now finished creating myGauss"
InitFunc(fitFunc)
fitit(job.dxh,fitFunc)
fitit(job.dyh,fitFunc)
fitit(job.dxsh,fitFunc)
fitit(job.dysh,fitFunc)
fitit(job.dphih,fitFunc)
fitit(job.dzxh,fitFunc)

job.dxsh.Draw()
